(** * Addresses / Labels*)
Require Import base.

Definition addr := BinPos.positive.

Section AddrEqType.
  Import BinPos.

  Fixpoint eq_addr (a1 a2 : addr) : bool :=
    match a1, a2 with
    | xH, xH => true
    | xI a1, xI a2 => eq_addr a1 a2
    | xO a1, xO a2 => eq_addr a1 a2
    | _, _ => false
    end.

  Lemma eq_addrP : Equality.axiom eq_addr.
  Proof.
    move=> a1 a2. apply: (iffP idP) => [|<-{a2}]; last by elim: a1.
      by elim: a1 a2 => [a1 ih|a1 ih|] [a2|a2|] //= /ih->.
  Qed.

  Canonical addr_eqMixin := EqMixin eq_addrP.
  Canonical addr_eqType := Eval hnf in EqType addr addr_eqMixin.
End AddrEqType.
